```
algos = ['MOEA U-NSGA-III', 'MOBO qNEHVI']

problem1 = get_problem("zdt1")
pareto = problem1.pareto_front()

N_TRIALS = 10
noise = 0
N_BATCH = 24
BATCH_SIZE = 8

train_qnehvi_all0 = loadtxt("ZDT1_train_qnehvi_24by8.csv", delimiter=',')
train_qnehvi_all0 = train_qnehvi_all0.reshape(10, 210, 10)
train_nsga3_all0 = loadtxt("ZDT1_train_nsga3_24by8.csv", delimiter=',')
train_nsga3_all0 = train_nsga3_all0.reshape(10, 210, 10)

hvs_qnehvi_all0 = loadtxt("ZDT1_hvs_qnehvi_24by8.csv", delimiter=',')
hvs_nsga3_all0 = loadtxt("ZDT1_hvs_nsga3_24by8.csv", delimiter=',')

train = train_qnehvi_all0

xlist, ylist = [], []

for trial in range(N_TRIALS):

    xlist.append(-train[trial][:,8:10][:,0])
    ylist.append(-train[trial][:,8:10][:,1])

x = np.array(xlist).reshape(-1)
y = np.array(ylist).reshape(-1)
xy = np.vstack([x,y])
z = gaussian_kde(xy)(xy)
idx = z.argsort()
x, y, z = x[idx], y[idx], z[idx]

train = train_nsga3_all0

xlist, ylist = [], []

for trial in range(N_TRIALS):

    xlist.append(-train[trial][:,8:10][:,0])
    ylist.append(-train[trial][:,8:10][:,1])

x1 = np.array(xlist).reshape(-1)
y1 = np.array(ylist).reshape(-1)
xy1 = np.vstack([x1,y1])
z1 = gaussian_kde(xy1)(xy1)
idx1 = z1.argsort()
x1, y1, z1 = x1[idx1], y1[idx1], z1[idx1]

norm = plt.Normalize(min(z.min(),z1.min()), max(z.max(),z1.max()))

fig, ax = plt.subplots(ncols = 2, figsize = (14,5))


ax[0].scatter(pareto[:,0],
              pareto[:,1], 
              c="r", s=3, marker=".", alpha=0.8)

ax[0].scatter(x1, y1, c=z1, s=3, norm=norm, cmap='magma')

ax[1].scatter(pareto[:,0],
              pareto[:,1], 
              c="r", s=3, marker=".", alpha=0.8)

ax[1].scatter(x, y, c=z, s=3, norm=norm, cmap='magma')


for i, train, letter in zip([0,1],
                            [train_nsga3_all0, train_qnehvi_all0],
                            ['a', 'b']):
    ax[i].set_title(f"{letter}) ZDT1 - {algos[i]}", fontsize=20)
    ax[i].set_xlabel('f1')
    ax[i].yaxis.set_major_formatter(StrMethodFormatter('{x:,.2f}')) # 2 decimal places

    ax[i].set_xlim(-0.05, 1.05)
    ax[i].set_ylim(-0.2, 7.5)
    
ax[0].set_ylabel('f2')

fig.tight_layout()

ax[0].text(-0.025, 0.1, f"mean HV={np.array(hvs_nsga3_all0).mean(axis=0)[-1]:.5f}", fontsize=14)
ax[1].text(-0.025, 0.1, f"mean HV={np.array(hvs_qnehvi_all0).mean(axis=0)[-1]:.5f}", fontsize=14)

sm = ScalarMappable(norm=norm, cmap='magma')
sm.set_array([])
fig.subplots_adjust(right=0.88)
cbar_ax = fig.add_axes([0.9, 0.15, 0.01, 0.7])
cbar = fig.colorbar(sm, cax=cbar_ax)
cbar.ax.set_title("PDF", fontsize=14)
```